package textBookEgs_Chapter3_exact;

import java.awt.Point;
import java.awt.Shape;
import java.awt.geom.Line2D;
import java.awt.geom.Rectangle2D;

public class Line {

	final int NEAR_THRESHOLD = 20;
	private Point startPoint;
	private Point endPoint;
	private Shape theShape;

	public Line(int x1, int y1, int x2, int y2) {
		startPoint = new Point(x1, y1);
		endPoint = new Point(x2, y2);
		theShape = new Line2D.Float(startPoint, endPoint);
	}

	public Point getEndPoint() {
		return endPoint;
	}
	
	public void setEndPoint(Point p) {
		endPoint = p;
	}


	public Point getStartPoint() {
		return startPoint;
	}

	public void setStartPoint(Point p) {
		startPoint = p;
	}

	public boolean isNearTo(Point point) {
		Rectangle2D proximalField = new Rectangle2D.Float(point.x, point.y,
				NEAR_THRESHOLD, NEAR_THRESHOLD);

		return theShape.intersects(proximalField);
	}
	
	public String toString() {
		return startPoint + " to " + endPoint;
	}

}
